/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         aalogparse_parse
#define yylex           aalogparse_lex
#define yyerror         aalogparse_error
#define yydebug         aalogparse_debug
#define yynerrs         aalogparse_nerrs


/* Copy the first part of user declarations.  */
#line 19 "grammar.y" /* yacc.c:339  */


/* set the following to non-zero to get bison to emit debugging
 * information about tokens given and rules matched. */
#define YYDEBUG 0
#include <string.h>
#include <aalogparse.h>
#include "parser.h"
#include "grammar.h"
#include "scanner.h"

aa_log_record *ret_record;

/* Since we're a library, on any errors we don't want to print out any
 * error messages. We should probably add a debug interface that does
 * emit messages when asked for. */
void aalogparse_error(void *scanner, char const *s)
{
        //printf("ERROR: %s\n", s);
	ret_record->event = AA_RECORD_INVALID;
}

struct aa_type_table {
	unsigned int audit_type;
	aa_record_event_type event;
};

static struct aa_type_table aa_type_table[] = {
	{AUDIT_APPARMOR_AUDIT,   AA_RECORD_AUDIT},
	{AUDIT_APPARMOR_ALLOWED, AA_RECORD_ALLOWED},
	{AUDIT_APPARMOR_DENIED,  AA_RECORD_DENIED},
	{AUDIT_APPARMOR_HINT,    AA_RECORD_HINT},
	{AUDIT_APPARMOR_STATUS,  AA_RECORD_STATUS},
	{AUDIT_APPARMOR_ERROR,   AA_RECORD_ERROR},
	{0,                      AA_RECORD_INVALID},
};

aa_record_event_type lookup_aa_event(unsigned int type)
{
	int i;

	for (i = 0; aa_type_table[i].audit_type != 0; i++)
		if (type == aa_type_table[i].audit_type)
			break;

	return aa_type_table[i].event;
}



#line 123 "grammar.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_AALOGPARSE_GRAMMAR_H_INCLUDED
# define YY_AALOGPARSE_GRAMMAR_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int aalogparse_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_DIGITS = 258,
    TOK_TYPE_UNKNOWN = 259,
    TOK_QUOTED_STRING = 260,
    TOK_ID = 261,
    TOK_MODE = 262,
    TOK_DMESG_STAMP = 263,
    TOK_AUDIT_DIGITS = 264,
    TOK_DATE_MONTH = 265,
    TOK_DATE = 266,
    TOK_TIME = 267,
    TOK_HEXSTRING = 268,
    TOK_TYPE_OTHER = 269,
    TOK_MSG_REST = 270,
    TOK_IP_ADDR = 271,
    TOK_EQUALS = 272,
    TOK_COLON = 273,
    TOK_MINUS = 274,
    TOK_OPEN_PAREN = 275,
    TOK_CLOSE_PAREN = 276,
    TOK_PERIOD = 277,
    TOK_QUESTION_MARK = 278,
    TOK_SINGLE_QUOTE = 279,
    TOK_TYPE_REJECT = 280,
    TOK_TYPE_AUDIT = 281,
    TOK_TYPE_COMPLAIN = 282,
    TOK_TYPE_HINT = 283,
    TOK_TYPE_STATUS = 284,
    TOK_TYPE_ERROR = 285,
    TOK_TYPE_AA_REJECT = 286,
    TOK_TYPE_AA_AUDIT = 287,
    TOK_TYPE_AA_COMPLAIN = 288,
    TOK_TYPE_AA_HINT = 289,
    TOK_TYPE_AA_STATUS = 290,
    TOK_TYPE_AA_ERROR = 291,
    TOK_TYPE_LSM_AVC = 292,
    TOK_TYPE_USER_AVC = 293,
    TOK_KEY_APPARMOR = 294,
    TOK_KEY_TYPE = 295,
    TOK_KEY_MSG = 296,
    TOK_KEY_OPERATION = 297,
    TOK_KEY_NAME = 298,
    TOK_KEY_NAME2 = 299,
    TOK_KEY_MASK = 300,
    TOK_KEY_DENIED_MASK = 301,
    TOK_KEY_REQUESTED_MASK = 302,
    TOK_KEY_ATTRIBUTE = 303,
    TOK_KEY_TASK = 304,
    TOK_KEY_PARENT = 305,
    TOK_KEY_MAGIC_TOKEN = 306,
    TOK_KEY_INFO = 307,
    TOK_KEY_PEER_INFO = 308,
    TOK_KEY_PID = 309,
    TOK_KEY_PEER_PID = 310,
    TOK_KEY_PROFILE = 311,
    TOK_KEY_PEER_PROFILE = 312,
    TOK_KEY_PEER = 313,
    TOK_AUDIT = 314,
    TOK_KEY_FAMILY = 315,
    TOK_KEY_SOCK_TYPE = 316,
    TOK_KEY_PROTOCOL = 317,
    TOK_KEY_NAMESPACE = 318,
    TOK_KEY_ERROR = 319,
    TOK_KEY_FSUID = 320,
    TOK_KEY_OUID = 321,
    TOK_KEY_UID = 322,
    TOK_KEY_AUID = 323,
    TOK_KEY_SAUID = 324,
    TOK_KEY_SES = 325,
    TOK_KEY_HOSTNAME = 326,
    TOK_KEY_ADDR = 327,
    TOK_KEY_TERMINAL = 328,
    TOK_KEY_EXE = 329,
    TOK_KEY_COMM = 330,
    TOK_KEY_CAPABILITY = 331,
    TOK_KEY_CAPNAME = 332,
    TOK_KEY_OFFSET = 333,
    TOK_KEY_TARGET = 334,
    TOK_KEY_LADDR = 335,
    TOK_KEY_FADDR = 336,
    TOK_KEY_LPORT = 337,
    TOK_KEY_FPORT = 338,
    TOK_KEY_BUS = 339,
    TOK_KEY_PATH = 340,
    TOK_KEY_INTERFACE = 341,
    TOK_KEY_MEMBER = 342,
    TOK_KEY_SIGNAL = 343,
    TOK_KEY_FSTYPE = 344,
    TOK_KEY_FLAGS = 345,
    TOK_KEY_SRCNAME = 346,
    TOK_SYSLOG_KERNEL = 347,
    TOK_SYSLOG_USER = 348
  };
#endif
/* Tokens.  */
#define TOK_DIGITS 258
#define TOK_TYPE_UNKNOWN 259
#define TOK_QUOTED_STRING 260
#define TOK_ID 261
#define TOK_MODE 262
#define TOK_DMESG_STAMP 263
#define TOK_AUDIT_DIGITS 264
#define TOK_DATE_MONTH 265
#define TOK_DATE 266
#define TOK_TIME 267
#define TOK_HEXSTRING 268
#define TOK_TYPE_OTHER 269
#define TOK_MSG_REST 270
#define TOK_IP_ADDR 271
#define TOK_EQUALS 272
#define TOK_COLON 273
#define TOK_MINUS 274
#define TOK_OPEN_PAREN 275
#define TOK_CLOSE_PAREN 276
#define TOK_PERIOD 277
#define TOK_QUESTION_MARK 278
#define TOK_SINGLE_QUOTE 279
#define TOK_TYPE_REJECT 280
#define TOK_TYPE_AUDIT 281
#define TOK_TYPE_COMPLAIN 282
#define TOK_TYPE_HINT 283
#define TOK_TYPE_STATUS 284
#define TOK_TYPE_ERROR 285
#define TOK_TYPE_AA_REJECT 286
#define TOK_TYPE_AA_AUDIT 287
#define TOK_TYPE_AA_COMPLAIN 288
#define TOK_TYPE_AA_HINT 289
#define TOK_TYPE_AA_STATUS 290
#define TOK_TYPE_AA_ERROR 291
#define TOK_TYPE_LSM_AVC 292
#define TOK_TYPE_USER_AVC 293
#define TOK_KEY_APPARMOR 294
#define TOK_KEY_TYPE 295
#define TOK_KEY_MSG 296
#define TOK_KEY_OPERATION 297
#define TOK_KEY_NAME 298
#define TOK_KEY_NAME2 299
#define TOK_KEY_MASK 300
#define TOK_KEY_DENIED_MASK 301
#define TOK_KEY_REQUESTED_MASK 302
#define TOK_KEY_ATTRIBUTE 303
#define TOK_KEY_TASK 304
#define TOK_KEY_PARENT 305
#define TOK_KEY_MAGIC_TOKEN 306
#define TOK_KEY_INFO 307
#define TOK_KEY_PEER_INFO 308
#define TOK_KEY_PID 309
#define TOK_KEY_PEER_PID 310
#define TOK_KEY_PROFILE 311
#define TOK_KEY_PEER_PROFILE 312
#define TOK_KEY_PEER 313
#define TOK_AUDIT 314
#define TOK_KEY_FAMILY 315
#define TOK_KEY_SOCK_TYPE 316
#define TOK_KEY_PROTOCOL 317
#define TOK_KEY_NAMESPACE 318
#define TOK_KEY_ERROR 319
#define TOK_KEY_FSUID 320
#define TOK_KEY_OUID 321
#define TOK_KEY_UID 322
#define TOK_KEY_AUID 323
#define TOK_KEY_SAUID 324
#define TOK_KEY_SES 325
#define TOK_KEY_HOSTNAME 326
#define TOK_KEY_ADDR 327
#define TOK_KEY_TERMINAL 328
#define TOK_KEY_EXE 329
#define TOK_KEY_COMM 330
#define TOK_KEY_CAPABILITY 331
#define TOK_KEY_CAPNAME 332
#define TOK_KEY_OFFSET 333
#define TOK_KEY_TARGET 334
#define TOK_KEY_LADDR 335
#define TOK_KEY_FADDR 336
#define TOK_KEY_LPORT 337
#define TOK_KEY_FPORT 338
#define TOK_KEY_BUS 339
#define TOK_KEY_PATH 340
#define TOK_KEY_INTERFACE 341
#define TOK_KEY_MEMBER 342
#define TOK_KEY_SIGNAL 343
#define TOK_KEY_FSTYPE 344
#define TOK_KEY_FLAGS 345
#define TOK_KEY_SRCNAME 346
#define TOK_SYSLOG_KERNEL 347
#define TOK_SYSLOG_USER 348

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 76 "grammar.y" /* yacc.c:355  */

	char	*t_str;
	long	t_long;

#line 354 "grammar.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int aalogparse_parse (void *scanner);

#endif /* !YY_AALOGPARSE_GRAMMAR_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 368 "grammar.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  15
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   321

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  94
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  24
/* YYNRULES -- Number of rules.  */
#define YYNRULES  101
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  271

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   348

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   171,   171,   172,   173,   176,   178,   179,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   194,   203,   205,
     207,   209,   211,   213,   219,   222,   225,   228,   239,   241,
     245,   246,   249,   251,   253,   255,   257,   259,   261,   263,
     265,   267,   269,   271,   273,   275,   277,   278,   279,   281,
     283,   285,   287,   289,   291,   293,   295,   297,   299,   301,
     303,   304,   305,   306,   308,   310,   316,   322,   323,   329,
     333,   338,   342,   344,   346,   348,   350,   352,   354,   356,
     358,   361,   363,   365,   368,   376,   377,   378,   379,   380,
     381,   384,   387,   390,   391,   392,   393,   395,   398,   399,
     402,   403
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_DIGITS", "TOK_TYPE_UNKNOWN",
  "TOK_QUOTED_STRING", "TOK_ID", "TOK_MODE", "TOK_DMESG_STAMP",
  "TOK_AUDIT_DIGITS", "TOK_DATE_MONTH", "TOK_DATE", "TOK_TIME",
  "TOK_HEXSTRING", "TOK_TYPE_OTHER", "TOK_MSG_REST", "TOK_IP_ADDR",
  "TOK_EQUALS", "TOK_COLON", "TOK_MINUS", "TOK_OPEN_PAREN",
  "TOK_CLOSE_PAREN", "TOK_PERIOD", "TOK_QUESTION_MARK", "TOK_SINGLE_QUOTE",
  "TOK_TYPE_REJECT", "TOK_TYPE_AUDIT", "TOK_TYPE_COMPLAIN",
  "TOK_TYPE_HINT", "TOK_TYPE_STATUS", "TOK_TYPE_ERROR",
  "TOK_TYPE_AA_REJECT", "TOK_TYPE_AA_AUDIT", "TOK_TYPE_AA_COMPLAIN",
  "TOK_TYPE_AA_HINT", "TOK_TYPE_AA_STATUS", "TOK_TYPE_AA_ERROR",
  "TOK_TYPE_LSM_AVC", "TOK_TYPE_USER_AVC", "TOK_KEY_APPARMOR",
  "TOK_KEY_TYPE", "TOK_KEY_MSG", "TOK_KEY_OPERATION", "TOK_KEY_NAME",
  "TOK_KEY_NAME2", "TOK_KEY_MASK", "TOK_KEY_DENIED_MASK",
  "TOK_KEY_REQUESTED_MASK", "TOK_KEY_ATTRIBUTE", "TOK_KEY_TASK",
  "TOK_KEY_PARENT", "TOK_KEY_MAGIC_TOKEN", "TOK_KEY_INFO",
  "TOK_KEY_PEER_INFO", "TOK_KEY_PID", "TOK_KEY_PEER_PID",
  "TOK_KEY_PROFILE", "TOK_KEY_PEER_PROFILE", "TOK_KEY_PEER", "TOK_AUDIT",
  "TOK_KEY_FAMILY", "TOK_KEY_SOCK_TYPE", "TOK_KEY_PROTOCOL",
  "TOK_KEY_NAMESPACE", "TOK_KEY_ERROR", "TOK_KEY_FSUID", "TOK_KEY_OUID",
  "TOK_KEY_UID", "TOK_KEY_AUID", "TOK_KEY_SAUID", "TOK_KEY_SES",
  "TOK_KEY_HOSTNAME", "TOK_KEY_ADDR", "TOK_KEY_TERMINAL", "TOK_KEY_EXE",
  "TOK_KEY_COMM", "TOK_KEY_CAPABILITY", "TOK_KEY_CAPNAME",
  "TOK_KEY_OFFSET", "TOK_KEY_TARGET", "TOK_KEY_LADDR", "TOK_KEY_FADDR",
  "TOK_KEY_LPORT", "TOK_KEY_FPORT", "TOK_KEY_BUS", "TOK_KEY_PATH",
  "TOK_KEY_INTERFACE", "TOK_KEY_MEMBER", "TOK_KEY_SIGNAL",
  "TOK_KEY_FSTYPE", "TOK_KEY_FLAGS", "TOK_KEY_SRCNAME",
  "TOK_SYSLOG_KERNEL", "TOK_SYSLOG_USER", "$accept", "log_message",
  "audit_type", "type_syntax", "new_syntax", "other_audit", "syslog_type",
  "audit_dispatch", "audit_msg", "audit_user_msg", "audit_id",
  "syslog_date", "key_list", "key", "apparmor_event", "key_pid",
  "key_peer_pid", "ignored_pid", "ignored_uid", "ignored_auid",
  "ignored_ses", "key_type", "safe_string", "protocol", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348
};
# endif

#define YYPACT_NINF -188

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-188)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
       7,    13,     9,    35,    36,    56,  -188,  -188,  -188,   210,
      53,    46,  -188,     8,    17,  -188,  -188,    49,    50,    60,
      62,    63,    64,    65,    66,    67,    68,    69,    71,    72,
      75,    76,    77,    79,    80,    81,    83,    85,    86,    87,
      89,   100,   102,   103,   104,   105,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   210,  -188,  -188,  -188,   -67,
    -188,   106,   106,   106,   106,   106,   106,   106,   106,   106,
     126,  -188,  -188,  -188,   128,  -188,    44,   140,   139,    14,
      14,   141,   144,   147,   155,   142,   158,   159,   160,   161,
     166,   167,    14,    14,   168,   170,   171,    26,    14,    11,
     175,   176,   177,    10,    15,    52,    14,    14,   179,   180,
     181,    14,   148,   172,   183,   184,   185,   186,   187,   188,
     189,   193,   211,   219,  -188,    -5,   210,   210,   174,   210,
     210,   210,   210,   210,   210,   210,   146,   203,   242,  -188,
    -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,
    -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,
    -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,
    -188,  -188,  -188,   266,  -188,  -188,  -188,  -188,  -188,  -188,
    -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,
    -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,
    -188,   -27,   260,   210,    17,   210,   210,  -188,   210,   210,
     210,   210,   210,   210,   210,    17,   210,   256,  -188,    16,
     210,    17,   277,   210,   210,   248,   157,   294,   264,   210,
     210,  -188,   210,   288,   239,  -188,   289,    17,   210,   305,
     292,   243,   301,   210,  -188,   309,   296,   244,   295,   210,
    -188,   312,   300,   278,   302,  -188,   315,   304,  -188,  -188,
    -188
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     2,     3,     4,     0,
       0,     0,    29,     0,     0,     1,    84,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    24,    30,    46,    47,     0,
      28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     5,     6,     7,     0,    25,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    31,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    85,
      86,    87,    88,    89,    90,    67,    53,    32,    98,    99,
      33,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    91,    92,    48,    49,    45,    50,    51,   101,   100,
      52,    34,    54,     0,    56,    57,    58,    60,    59,    61,
      63,    62,    64,    65,    66,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,     0,     0,     0,     0,    23,    14,    17,     8,     9,
      10,    11,    12,    13,    15,     0,     0,     0,    55,     0,
       0,     0,     0,    18,     0,     0,     0,     0,     0,    20,
       0,    97,    19,     0,     0,    16,     0,     0,    21,     0,
       0,     0,     0,     0,    93,     0,     0,     0,     0,    22,
      94,     0,     0,     0,     0,    95,     0,     0,    27,    96,
      26
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,    37,  -188,
    -124,  -188,  -135,   -65,  -188,  -188,  -188,  -188,  -188,  -188,
    -188,  -187,   -53,  -188
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     5,     6,    81,    82,    83,     7,     8,     9,   147,
      85,    10,    65,    66,   155,    67,    68,   244,   251,   257,
     263,   214,   160,   180
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint16 yytable[] =
{
     134,   215,   216,   211,   218,   219,   220,   221,   222,   223,
     224,   213,    71,   212,   182,   158,    11,     1,     2,   158,
     158,    12,    72,   159,   231,   135,   136,   159,   159,   178,
     183,   179,   229,   187,   238,   212,   148,   161,   189,    73,
      74,    75,    76,    77,    78,    79,    80,     3,     4,   173,
     174,   247,    13,    14,    84,   181,    15,   158,    70,    69,
     188,   190,   192,   193,   194,   159,    86,    87,   198,   149,
     150,   151,   152,   153,   154,   191,    84,    88,   233,    89,
      90,    91,    92,    93,    94,    95,    96,   230,    97,    98,
     234,   236,    99,   100,   101,   239,   102,   103,   104,   242,
     105,   235,   106,   107,   108,   248,   109,   240,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   110,   259,   111,
     112,   113,   114,   253,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   156,   157,   166,   162,     4,   148,   163,
     134,   134,   164,   134,   134,   134,   134,   134,   134,   134,
     165,   167,   168,   225,   199,   169,   170,   146,   134,   171,
     172,   134,    16,   175,   134,   176,   177,   134,   184,   185,
     186,   245,   195,   134,   197,   196,   201,   202,   200,   217,
     203,   204,   205,   206,   134,   207,    17,    18,   208,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,   209,    36,    37,    38,
      39,    40,    41,    42,   210,    16,    43,   226,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    17,
      18,   227,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,   228,
      36,    37,    38,    39,    40,    41,    42,   232,   237,    43,
     241,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,   243,   246,   212,   249,   250,   252,   254,   255,
     258,   256,   260,   261,   262,   265,   264,   266,   269,   267,
     268,   270
};

static const yytype_uint16 yycheck[] =
{
      65,   136,   137,     8,   139,   140,   141,   142,   143,   144,
     145,   135,     4,    40,     3,     5,     3,    10,    11,     5,
       5,    12,    14,    13,   211,    92,    93,    13,    13,     3,
      19,     5,    59,    23,    18,    40,    20,    90,    23,    31,
      32,    33,    34,    35,    36,    37,    38,    40,    41,   102,
     103,   238,    17,    17,    59,   108,     0,     5,    12,     6,
     113,   114,   115,   116,   117,    13,    17,    17,   121,    25,
      26,    27,    28,    29,    30,    23,    59,    17,   213,    17,
      17,    17,    17,    17,    17,    17,    17,   211,    17,    17,
     214,   226,    17,    17,    17,   230,    17,    17,    17,   234,
      17,   225,    17,    17,    17,   240,    17,   231,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    17,   253,    17,
      17,    17,    17,   247,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,     3,     5,     3,     5,    41,    20,     5,
     215,   216,     5,   218,   219,   220,   221,   222,   223,   224,
       5,     3,     3,    17,    16,     5,     5,    41,   233,     3,
       3,   236,    15,     5,   239,     5,     5,   242,     3,     3,
       3,    24,     3,   248,     3,     5,     3,     3,    16,    15,
       5,     5,     5,     5,   259,     6,    39,    40,     5,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,     5,    60,    61,    62,
      63,    64,    65,    66,     5,    15,    69,    24,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    39,
      40,     9,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,     3,
      60,    61,    62,    63,    64,    65,    66,    17,    22,    69,
       3,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    54,     9,    40,    17,    67,    18,     3,    17,
       9,    68,     3,    17,    70,     3,    21,    17,     3,    41,
      18,    17
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    10,    11,    40,    41,    95,    96,   100,   101,   102,
     105,     3,    12,    17,    17,     0,    15,    39,    40,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    60,    61,    62,    63,
      64,    65,    66,    69,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,   106,   107,   109,   110,     6,
      12,     4,    14,    31,    32,    33,    34,    35,    36,    37,
      38,    97,    98,    99,    59,   104,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,   107,    92,    93,   102,   102,   102,
     102,   102,   102,   102,   102,   102,    41,   103,    20,    25,
      26,    27,    28,    29,    30,   108,     3,     5,     5,    13,
     116,   116,     5,     5,     5,     5,     3,     3,     3,     5,
       5,     3,     3,   116,   116,     5,     5,     5,     3,     5,
     117,   116,     3,    19,     3,     3,     3,    23,   116,    23,
     116,    23,   116,   116,   116,     3,     5,     3,   116,    16,
      16,     3,     3,     5,     5,     5,     5,     6,     5,     5,
       5,     8,    40,   104,   115,   106,   106,    15,   106,   106,
     106,   106,   106,   106,   106,    17,    24,     9,     3,    59,
     104,   115,    17,   106,   104,   104,   106,    22,    18,   106,
     104,     3,   106,    54,   111,    24,     9,   115,   106,    17,
      67,   112,    18,   104,     3,    17,    68,   113,     9,   106,
       3,    17,    70,   114,    21,     3,    17,    41,    18,     3,
      17
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    94,    95,    95,    95,    96,    97,    97,    98,    98,
      98,    98,    98,    98,    98,    98,    98,    99,   100,   100,
     100,   100,   100,   100,   101,   102,   103,   104,   105,   105,
     106,   106,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   108,   108,   108,   108,   108,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   116,
     117,   117
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     3,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     3,     5,     6,
       6,     7,     9,     4,     2,     3,     9,     9,     3,     2,
       1,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (scanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, scanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, void *scanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (scanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, void *scanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, scanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, void *scanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , scanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, scanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, void *scanner)
{
  YYUSE (yyvaluep);
  YYUSE (scanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void *scanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, scanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 178 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1666 "grammar.c" /* yacc.c:1646  */
    break;

  case 8:
#line 183 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_DENIED; }
#line 1672 "grammar.c" /* yacc.c:1646  */
    break;

  case 9:
#line 184 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_AUDIT; }
#line 1678 "grammar.c" /* yacc.c:1646  */
    break;

  case 10:
#line 185 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ALLOWED; }
#line 1684 "grammar.c" /* yacc.c:1646  */
    break;

  case 11:
#line 186 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_HINT; }
#line 1690 "grammar.c" /* yacc.c:1646  */
    break;

  case 12:
#line 187 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_STATUS; }
#line 1696 "grammar.c" /* yacc.c:1646  */
    break;

  case 13:
#line 188 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ERROR; }
#line 1702 "grammar.c" /* yacc.c:1646  */
    break;

  case 14:
#line 189 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = lookup_aa_event((yyvsp[-2].t_long)); }
#line 1708 "grammar.c" /* yacc.c:1646  */
    break;

  case 17:
#line 195 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->operation = (yyvsp[-2].t_str);
		ret_record->event = AA_RECORD_INVALID;
		ret_record->info = (yyvsp[0].t_str);
	}
#line 1718 "grammar.c" /* yacc.c:1646  */
    break;

  case 18:
#line 204 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-3].t_str)); }
#line 1724 "grammar.c" /* yacc.c:1646  */
    break;

  case 19:
#line 206 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-4].t_str)); }
#line 1730 "grammar.c" /* yacc.c:1646  */
    break;

  case 20:
#line 208 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-4].t_str)); free((yyvsp[-2].t_str)); }
#line 1736 "grammar.c" /* yacc.c:1646  */
    break;

  case 21:
#line 210 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-5].t_str)); free((yyvsp[-3].t_str)); }
#line 1742 "grammar.c" /* yacc.c:1646  */
    break;

  case 22:
#line 212 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-7].t_str)); free((yyvsp[-5].t_str)); }
#line 1748 "grammar.c" /* yacc.c:1646  */
    break;

  case 23:
#line 214 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-2].t_str)); }
#line 1754 "grammar.c" /* yacc.c:1646  */
    break;

  case 24:
#line 219 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1760 "grammar.c" /* yacc.c:1646  */
    break;

  case 27:
#line 229 "grammar.y" /* yacc.c:1646  */
    {
		if (!asprintf(&ret_record->audit_id, "%s.%s:%s", (yyvsp[-6].t_str), (yyvsp[-4].t_str), (yyvsp[-2].t_str)))
			yyerror(scanner, YY_("Out of memory"));
		ret_record->epoch = atol((yyvsp[-6].t_str));
		ret_record->audit_sub_id = atoi((yyvsp[-2].t_str));
		free((yyvsp[-6].t_str));
		free((yyvsp[-4].t_str));
		free((yyvsp[-2].t_str));
	}
#line 1774 "grammar.c" /* yacc.c:1646  */
    break;

  case 28:
#line 240 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[-2].t_str)); free((yyvsp[0].t_str)); /* do nothing */ }
#line 1780 "grammar.c" /* yacc.c:1646  */
    break;

  case 29:
#line 242 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[-1].t_str)); free((yyvsp[0].t_str)); /* do nothing */ }
#line 1786 "grammar.c" /* yacc.c:1646  */
    break;

  case 32:
#line 250 "grammar.y" /* yacc.c:1646  */
    { ret_record->operation = (yyvsp[0].t_str);}
#line 1792 "grammar.c" /* yacc.c:1646  */
    break;

  case 33:
#line 252 "grammar.y" /* yacc.c:1646  */
    { ret_record->name = (yyvsp[0].t_str);}
#line 1798 "grammar.c" /* yacc.c:1646  */
    break;

  case 34:
#line 254 "grammar.y" /* yacc.c:1646  */
    { ret_record->namespace = (yyvsp[0].t_str);}
#line 1804 "grammar.c" /* yacc.c:1646  */
    break;

  case 35:
#line 256 "grammar.y" /* yacc.c:1646  */
    { ret_record->name2 = (yyvsp[0].t_str);}
#line 1810 "grammar.c" /* yacc.c:1646  */
    break;

  case 36:
#line 258 "grammar.y" /* yacc.c:1646  */
    { ret_record->denied_mask = (yyvsp[0].t_str);}
#line 1816 "grammar.c" /* yacc.c:1646  */
    break;

  case 37:
#line 260 "grammar.y" /* yacc.c:1646  */
    { ret_record->denied_mask = (yyvsp[0].t_str);}
#line 1822 "grammar.c" /* yacc.c:1646  */
    break;

  case 38:
#line 262 "grammar.y" /* yacc.c:1646  */
    { ret_record->requested_mask = (yyvsp[0].t_str);}
#line 1828 "grammar.c" /* yacc.c:1646  */
    break;

  case 39:
#line 264 "grammar.y" /* yacc.c:1646  */
    { ret_record->attribute = (yyvsp[0].t_str);}
#line 1834 "grammar.c" /* yacc.c:1646  */
    break;

  case 40:
#line 266 "grammar.y" /* yacc.c:1646  */
    { ret_record->task = (yyvsp[0].t_long);}
#line 1840 "grammar.c" /* yacc.c:1646  */
    break;

  case 41:
#line 268 "grammar.y" /* yacc.c:1646  */
    { ret_record->parent = (yyvsp[0].t_long);}
#line 1846 "grammar.c" /* yacc.c:1646  */
    break;

  case 42:
#line 270 "grammar.y" /* yacc.c:1646  */
    { ret_record->magic_token = (yyvsp[0].t_long);}
#line 1852 "grammar.c" /* yacc.c:1646  */
    break;

  case 43:
#line 272 "grammar.y" /* yacc.c:1646  */
    { ret_record->info = (yyvsp[0].t_str);}
#line 1858 "grammar.c" /* yacc.c:1646  */
    break;

  case 44:
#line 274 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer_info = (yyvsp[0].t_str);}
#line 1864 "grammar.c" /* yacc.c:1646  */
    break;

  case 45:
#line 276 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer = (yyvsp[0].t_str);}
#line 1870 "grammar.c" /* yacc.c:1646  */
    break;

  case 48:
#line 280 "grammar.y" /* yacc.c:1646  */
    { ret_record->profile = (yyvsp[0].t_str);}
#line 1876 "grammar.c" /* yacc.c:1646  */
    break;

  case 49:
#line 282 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer_profile = (yyvsp[0].t_str);}
#line 1882 "grammar.c" /* yacc.c:1646  */
    break;

  case 50:
#line 284 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_family = (yyvsp[0].t_str);}
#line 1888 "grammar.c" /* yacc.c:1646  */
    break;

  case 51:
#line 286 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_sock_type = (yyvsp[0].t_str);}
#line 1894 "grammar.c" /* yacc.c:1646  */
    break;

  case 52:
#line 288 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_protocol = (yyvsp[0].t_str);}
#line 1900 "grammar.c" /* yacc.c:1646  */
    break;

  case 53:
#line 290 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = lookup_aa_event((yyvsp[0].t_long));}
#line 1906 "grammar.c" /* yacc.c:1646  */
    break;

  case 54:
#line 292 "grammar.y" /* yacc.c:1646  */
    { ret_record->error_code = (yyvsp[0].t_long);}
#line 1912 "grammar.c" /* yacc.c:1646  */
    break;

  case 55:
#line 294 "grammar.y" /* yacc.c:1646  */
    { ret_record->error_code = (yyvsp[0].t_long);}
#line 1918 "grammar.c" /* yacc.c:1646  */
    break;

  case 56:
#line 296 "grammar.y" /* yacc.c:1646  */
    { ret_record->fsuid = (yyvsp[0].t_long);}
#line 1924 "grammar.c" /* yacc.c:1646  */
    break;

  case 57:
#line 298 "grammar.y" /* yacc.c:1646  */
    { ret_record->ouid = (yyvsp[0].t_long);}
#line 1930 "grammar.c" /* yacc.c:1646  */
    break;

  case 58:
#line 300 "grammar.y" /* yacc.c:1646  */
    { /* Ignore - Source audit ID from user AVC messages */ }
#line 1936 "grammar.c" /* yacc.c:1646  */
    break;

  case 59:
#line 302 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[0].t_str)); /* Ignore - hostname from user AVC messages */ }
#line 1942 "grammar.c" /* yacc.c:1646  */
    break;

  case 63:
#line 307 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[0].t_str)); /* Ignore - IP address from user AVC messages */ }
#line 1948 "grammar.c" /* yacc.c:1646  */
    break;

  case 64:
#line 309 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[0].t_str)); /* Ignore - TTY from user AVC messages */ }
#line 1954 "grammar.c" /* yacc.c:1646  */
    break;

  case 65:
#line 311 "grammar.y" /* yacc.c:1646  */
    { /* Free existing arrays because exe= and comm= maps to the same
	     aa_log_record member */
	  free(ret_record->comm);
	  ret_record->comm = (yyvsp[0].t_str);
	}
#line 1964 "grammar.c" /* yacc.c:1646  */
    break;

  case 66:
#line 317 "grammar.y" /* yacc.c:1646  */
    { /* Free existing arrays because exe= and comm= maps to the same
	     aa_log_record member */
	  free(ret_record->comm);
	  ret_record->comm = (yyvsp[0].t_str);
	}
#line 1974 "grammar.c" /* yacc.c:1646  */
    break;

  case 68:
#line 324 "grammar.y" /* yacc.c:1646  */
    { /* need to reverse map number to string, need to figure out
	   * how to get auto generation of reverse mapping table into
	   * autotools Makefile.  For now just drop assumming capname is
	   * present which it should be with current kernels */
	}
#line 1984 "grammar.c" /* yacc.c:1646  */
    break;

  case 69:
#line 330 "grammar.y" /* yacc.c:1646  */
    { /* capname used to be reported in name */
	  ret_record->name = (yyvsp[0].t_str);
	}
#line 1992 "grammar.c" /* yacc.c:1646  */
    break;

  case 70:
#line 334 "grammar.y" /* yacc.c:1646  */
    { /* offset is used for reporting where an error occured unpacking
	   * loaded policy.  We can just drop this currently
	   */
	}
#line 2001 "grammar.c" /* yacc.c:1646  */
    break;

  case 71:
#line 339 "grammar.y" /* yacc.c:1646  */
    { /* target was always name2 in the past */
	  ret_record->name2 = (yyvsp[0].t_str);
	}
#line 2009 "grammar.c" /* yacc.c:1646  */
    break;

  case 72:
#line 343 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_local_addr = (yyvsp[0].t_str);}
#line 2015 "grammar.c" /* yacc.c:1646  */
    break;

  case 73:
#line 345 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_foreign_addr = (yyvsp[0].t_str);}
#line 2021 "grammar.c" /* yacc.c:1646  */
    break;

  case 74:
#line 347 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_local_port = (yyvsp[0].t_long);}
#line 2027 "grammar.c" /* yacc.c:1646  */
    break;

  case 75:
#line 349 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_foreign_port = (yyvsp[0].t_long);}
#line 2033 "grammar.c" /* yacc.c:1646  */
    break;

  case 76:
#line 351 "grammar.y" /* yacc.c:1646  */
    { ret_record->dbus_bus = (yyvsp[0].t_str); }
#line 2039 "grammar.c" /* yacc.c:1646  */
    break;

  case 77:
#line 353 "grammar.y" /* yacc.c:1646  */
    { ret_record->dbus_path = (yyvsp[0].t_str); }
#line 2045 "grammar.c" /* yacc.c:1646  */
    break;

  case 78:
#line 355 "grammar.y" /* yacc.c:1646  */
    { ret_record->dbus_interface = (yyvsp[0].t_str); }
#line 2051 "grammar.c" /* yacc.c:1646  */
    break;

  case 79:
#line 357 "grammar.y" /* yacc.c:1646  */
    { ret_record->dbus_member = (yyvsp[0].t_str); }
#line 2057 "grammar.c" /* yacc.c:1646  */
    break;

  case 80:
#line 359 "grammar.y" /* yacc.c:1646  */
    { ret_record->signal = (yyvsp[0].t_str); }
#line 2063 "grammar.c" /* yacc.c:1646  */
    break;

  case 81:
#line 362 "grammar.y" /* yacc.c:1646  */
    { ret_record->fs_type = (yyvsp[0].t_str); }
#line 2069 "grammar.c" /* yacc.c:1646  */
    break;

  case 82:
#line 364 "grammar.y" /* yacc.c:1646  */
    { ret_record->flags = (yyvsp[0].t_str); }
#line 2075 "grammar.c" /* yacc.c:1646  */
    break;

  case 83:
#line 366 "grammar.y" /* yacc.c:1646  */
    { ret_record->src_name = (yyvsp[0].t_str); }
#line 2081 "grammar.c" /* yacc.c:1646  */
    break;

  case 84:
#line 369 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->event = AA_RECORD_INVALID;
		ret_record->info = (yyvsp[0].t_str);
	}
#line 2090 "grammar.c" /* yacc.c:1646  */
    break;

  case 85:
#line 376 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_DENIED; }
#line 2096 "grammar.c" /* yacc.c:1646  */
    break;

  case 86:
#line 377 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_AUDIT; }
#line 2102 "grammar.c" /* yacc.c:1646  */
    break;

  case 87:
#line 378 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ALLOWED; }
#line 2108 "grammar.c" /* yacc.c:1646  */
    break;

  case 88:
#line 379 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_HINT; }
#line 2114 "grammar.c" /* yacc.c:1646  */
    break;

  case 89:
#line 380 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_STATUS; }
#line 2120 "grammar.c" /* yacc.c:1646  */
    break;

  case 90:
#line 381 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ERROR; }
#line 2126 "grammar.c" /* yacc.c:1646  */
    break;

  case 91:
#line 384 "grammar.y" /* yacc.c:1646  */
    { ret_record->pid = (yyvsp[0].t_long); }
#line 2132 "grammar.c" /* yacc.c:1646  */
    break;

  case 92:
#line 387 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer_pid = (yyvsp[0].t_long); }
#line 2138 "grammar.c" /* yacc.c:1646  */
    break;

  case 93:
#line 390 "grammar.y" /* yacc.c:1646  */
    { /* DROP */ }
#line 2144 "grammar.c" /* yacc.c:1646  */
    break;

  case 94:
#line 391 "grammar.y" /* yacc.c:1646  */
    { /* DROP */ }
#line 2150 "grammar.c" /* yacc.c:1646  */
    break;

  case 95:
#line 392 "grammar.y" /* yacc.c:1646  */
    { /* DROP */ }
#line 2156 "grammar.c" /* yacc.c:1646  */
    break;

  case 96:
#line 393 "grammar.y" /* yacc.c:1646  */
    { /* DROP */ }
#line 2162 "grammar.c" /* yacc.c:1646  */
    break;

  case 97:
#line 395 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = lookup_aa_event((yyvsp[0].t_long)); }
#line 2168 "grammar.c" /* yacc.c:1646  */
    break;

  case 101:
#line 404 "grammar.y" /* yacc.c:1646  */
    { /* FIXME: this should probably convert back to a string proto name */
	  (yyval.t_str) = ipproto_to_string((yyvsp[0].t_long));
	}
#line 2176 "grammar.c" /* yacc.c:1646  */
    break;


#line 2180 "grammar.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (scanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (scanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, scanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, scanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (scanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, scanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, scanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 408 "grammar.y" /* yacc.c:1906  */


aa_log_record *
_parse_yacc(char *str)
{
	/* yydebug = 1;  */
	YY_BUFFER_STATE lex_buf;
	yyscan_t scanner;
	int parser_return;

	ret_record = NULL;
	ret_record = (aa_log_record *) malloc(sizeof(aa_log_record));

	_init_log_record(ret_record);

	if (ret_record == NULL)
		return NULL;

#if (YYDEBUG != 0)
	yydebug = 1;
#endif

	aalogparse_lex_init(&scanner);
	lex_buf = aalogparse__scan_string(str, scanner);
	parser_return = aalogparse_parse(scanner);
	aalogparse__delete_buffer(lex_buf, scanner);
	aalogparse_lex_destroy(scanner);
	return ret_record;
}
